#pragma once
#include <kr2_program_api/api_v1/program_interface.h>
#include "communication/bridge/connection_lifecycle/i_connection_state_machine.h"
#include "communication/bridge/i_bridge_client.h"
#include <memory>

namespace spin
{
    class IConnectionFactory
    {
    public:
        virtual ~IConnectionFactory() = default;

        virtual std::shared_ptr<IConnectionStateMachine> createStateMachine(boost::shared_ptr<kr2_program_api::ProgramInterface> api, std::shared_ptr<IBridgeClient> bridgeClient) = 0;
    };
} // namespace spin
